#include <windows.h>

//Acquisition Analogique
#define ADR_Voie_Active 0 //................... 8 bit
#define ADR_Voie_Gain 1 //..................... 24 bit
#define ADR_Acquisition_Skip 4 //.............. 40 bit
#define ADR_Acquisition_NbPoint 9 //........... 18 bit
#define ADR_CAN_Differentiel 12 //............. 4 bit


//Emmision Analogique
#define ADR_DAC0_Nbpoint 13 //................. 18 bit
#define ADR_DAC1_Nbpoint 16 //................. 18 bit
#define ADR_DAC0_Skip 19 //.................... 40 bit
#define ADR_DAC1_Skip 24 //.................... 40 bit
#define ADR_DAC_MonoCoup 0x4C // ............... 2 bit

// Triger/PreTRiger
#define ADR_Config_Triger 29 //................ 7 bit
#define ADR_Seuil_Triger 30 //................. 12 bit
#define ADR_NbPoint_PreTriger 32 //............ 18 bit
#define ADR_Hysteresis_Triger 35 //............ 8 bit

// divers
#define ADR_Start 36 //........................ 8 bit
#define ADR_Flag 37 //......................... 3 bit

// Timer
#define ADR_Timer_Config 38 //................. 8 bit
#define ADR_Timer_Hysteresis 39 //............. 32 bit
#define ADR_Timer_Fenetre 43 //................ 48 bit
#define ADR_Timer_DAta 77 //................... 48 bit

//logique
#define ADR_Port_B_OE 61 //.................... 2 bit
#define ADR_Port_C_OE 62 //.................... 8 bit
#define ADR_Port_B 63 //....................... 8 bit
#define ADR_Port_C 64 //....................... 8 bit

//capteur
#define ADR_IDF_Capteur0 65 //................. 8 bit
#define ADR_IDF_Capteur1 66 //................. 8 bit
#define ADR_IDF_Capteur2 67 //................. 8 bit
#define ADR_IDF_Capteur3 68 //................. 8 bit

//RAM
#define ADR_RAM_Remplissage_Actif 69 //........ 1 bit
#define ADR_RAM_Remplissage_Debut 70 //........ 18 bit
#define ADR_RAM_Remplissage_Fin 73 //.......... 18 bit

//Acces Directe (Entree et sortie)
#define ADR_Voie0_Directe 83 //................ 12 bit
#define ADR_Voie1_Directe 85 //................ 12 bit
#define ADR_Voie2_Directe 87 //................ 12 bit
#define ADR_Voie3_Directe 89 //................ 12 bit
#define ADR_Voie4_Directe 91 //................ 12 bit
#define ADR_Voie5_Directe 93 //................ 12 bit
#define ADR_Voie6_Directe 95 //................ 12 bit
#define ADR_Voie7_Directe 97 //................ 12 bit

#define ADR_Dac0_Direct 100 //................. 12 bit
#define ADR_Dac1_Direct 102 //................. 12 bit

//..............................................................................
// localistation des bits
#define Bit_Port_B_Low_OE 0 //................. 1 bit
#define Bit_Port_B_High_OE 1 //................ 1 bit

#define Bit_Trig_Externe 0 //.................. 1 bit
#define Bit_Trig_Seuil 1 //.................... 1 bit
#define Bit_Trig_Front_Montant 2 //............ 1 bit
#define Bit_Trig_Souple 3 //................... 1 bit
#define Bit_Trig_NumeroVoie 4 //............... 3 bit

#define Bit_Diff_CAN0 0 //..................... 1 bit
#define Bit_Diff_CAN1 1 //..................... 1 bit
#define Bit_Diff_CAN2 2 //..................... 1 bit
#define Bit_Diff_CAN3 3 //..................... 1 bit

#define Bit_Voie_Active0 0 //.................. 1 bit
#define Bit_Voie_Active1 1 //.................. 1 bit
#define Bit_Voie_Active2 2 //.................. 1 bit
#define Bit_Voie_Active3 3 //.................. 1 bit
#define Bit_Voie_Active4 4 //.................. 1 bit
#define Bit_Voie_Active5 5 //.................. 1 bit
#define Bit_Voie_Active6 6 //.................. 1 bit
#define Bit_Voie_Active7 7 //.................. 1 bit

#define Bit_Gain_Voie0 0 //.................... 1 bit
#define Bit_Gain_Voie1 3 //.................... 1 bit
#define Bit_Gain_Voie2 6 //.................... 1 bit
#define Bit_Gain_Voie3 9 //.................... 1 bit
#define Bit_Gain_Voie4 12 //................... 1 bit
#define Bit_Gain_Voie5 15 //................... 1 bit
#define Bit_Gain_Voie6 18 //................... 1 bit
#define Bit_Gain_Voie7 21 //................... 1 bit

#define Bit_Start_CAN 0 //..................... 1 bit
#define Bit_Start_DAC0 1 //.................... 1 bit
#define Bit_Start_DAC1 2 //.................... 1 bit
#define Bit_Start_Timer 3 //................... 1 bit
#define Bit_Start_Direct 4 //.................. 1 bit
#define Bit_Latch_Direct 5 //.................. 1 bit
#define Bit_RAZ_Timer 6 //..................... 1 bit
#define Bit_Mode_Permant 7 //.................. 1 bit

#define Bit_Flag_Timer_OverFlow 0 //........... 1 bit
#define Bit_Flag_Timer_Resultat_OK 1 //........ 1 bit
#define Bit_Flag_Acquisition_10Mhz 2 //........ 1 bit

//..............................................................................
// Taille des registre
#define Taille_Registre_Gain 24
#define Taille_Registre_Acquisition_Skip 40
#define Taille_Registre_Seuil_Triger 12
#define Taille_Registre_NbPoint_PreTriger 18
#define Taille_Registre_Acquisition_NbPoint 18
#define Taille_Registre_CAN_Differentiel 4
#define Taille_Registre_Config_Triger 7
#define Taille_Registre_Port_B_OE 2
#define Taille_Registre_Timer_Hysteresis 32
#define Taille_Registre_Timer_Fenetre 48
#define Taille_Registre_Timer_DAta 48
#define Taille_Registre_Voie_Direct 16

#define Taille_Registre_DAC0_Nbpoint 18
#define Taille_Registre_DAC1_Nbpoint 18
#define Taille_Registre_DAC0_Skip 40
#define Taille_Registre_DAC1_Skip 40

#define Taille_Registre_RAM_Remplissage_Actif 1
#define Taille_Registre_RAM_Remplissage_Debut 18
#define Taille_Registre_RAM_Remplissage_Fin 18


#define DureeSkipAcquisition 100E-9
#define DureeSkipEmmission 200E-9

//..............................................................................
// Taille des sous registre
#define Taille_Gain 3
#define Taille_Voie_Triger 3



#pragma pack(2)
typedef  struct // 379 octets
{
  BYTE Reserved;
  char SerialNumber[12];
  float Ampli_EA [4][4] ;
  float Offset_EA [8][4];
  float Offset_EADiff [4][4] ;
  float dummy [4][4] ;
  float Ampli_SA [2];
  float Offset_SA [2];

  double DateEtalonnage;//TDateTime
  double DateCablage;//TDateTime
  char NumeroSerieCablage[12];
} TCalibrageSP5;



typedef struct TCalibrageSP5bis
{
  BYTE SerialNumber[512];
} TCalibrageSP5bis; 

typedef TCalibrageSP5* TPrtCalibrageSP5;

typedef unsigned short int TFifoSP5[256];
typedef TFifoSP5* TPtrFifoSP5;



typedef void (CALLBACK Type_SP5_Reset)(void);
typedef BOOL (CALLBACK Type_SP5_Present)(void);
typedef unsigned char (CALLBACK Type_SP5_LireRegistre)(unsigned char);
typedef void (CALLBACK Type_SP5_EcrireRegistre)(unsigned char,unsigned char);
typedef void (CALLBACK Type_SP5_ViderFifo)(void);
typedef int (CALLBACK Type_SP5_TailleTransfertFifo)(int);
typedef void (CALLBACK Type_SP5_EcrireFifo)(TPtrFifoSP5,int);
typedef void (CALLBACK Type_SP5_RecupereCalibration)(TPrtCalibrageSP5);

typedef int (CALLBACK Type_SP5_LireFifo)(TPtrFifoSP5);

